package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.OrgSector;
import com.sa.ibiz.demo.demo.domain.WXAccount;

/**
 * 实体[WXOrgSector] 数据对象
 */
@TableName(value = "T_SRFWXORGSECTOR",resultMap = "WXOrgSectorResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WXOrgSector extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private OrgSector orgsector;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WXAccount wxaccount;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private Integer deptid;
    private String memo;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.ORGSECTORID)
    private String orgsectorid;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.ORGSECTORNAME)
    @TableField(exist = false)//逻辑属性
    private String orgsectorname;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String wxaccountid;
    private String wxaccountname;
    @TableId(value= "wxorgsectorid",type=IdType.UUID)//指定主键生成策略
    private String wxorgsectorid;
    private String wxorgsectorname;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[部门编号]
     *  @param deptid
     */
    public void setDeptid(Integer deptid){
        this.deptid = deptid;
        this.set("deptiddirtyflag",true);
    }
    /**
     *  获取属性值[部门编号]
     */
    public Integer getDeptid(){
        return this.deptid;
    }
    /**
     *  重置属性值[部门编号]
     */
    public void resetDeptid(){
        this.set("deptiddirtyflag",false);
        this.deptid = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[机构部门]
     *  @param orgsectorid
     */
    public void setOrgsectorid(String orgsectorid){
        if(StringUtils.isEmpty(orgsectorid))
            orgsectorid=null;
        this.orgsectorid = orgsectorid;
        this.set("orgsectoriddirtyflag",true);
    }
    /**
     *  获取属性值[机构部门]
     */
    public String getOrgsectorid(){
        return this.orgsectorid;
    }
    /**
     *  重置属性值[机构部门]
     */
    public void resetOrgsectorid(){
        this.set("orgsectoriddirtyflag",false);
        this.orgsectorid = null;
    }
    /**
     *  设置属性值[机构部门]
     *  @param orgsectorname
     */
    public void setOrgsectorname(String orgsectorname){
        if(StringUtils.isEmpty(orgsectorname))
            orgsectorname=null;
        this.orgsectorname = orgsectorname;
        this.set("orgsectornamedirtyflag",true);
    }
    /**
     *  获取属性值[机构部门]
     */
    public String getOrgsectorname(){
        return this.orgsectorname;
    }
    /**
     *  重置属性值[机构部门]
     */
    public void resetOrgsectorname(){
        this.set("orgsectornamedirtyflag",false);
        this.orgsectorname = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[微信公众号]
     *  @param wxaccountid
     */
    public void setWxaccountid(String wxaccountid){
        if(StringUtils.isEmpty(wxaccountid))
            wxaccountid=null;
        this.wxaccountid = wxaccountid;
        this.set("wxaccountiddirtyflag",true);
    }
    /**
     *  获取属性值[微信公众号]
     */
    public String getWxaccountid(){
        return this.wxaccountid;
    }
    /**
     *  重置属性值[微信公众号]
     */
    public void resetWxaccountid(){
        this.set("wxaccountiddirtyflag",false);
        this.wxaccountid = null;
    }
    /**
     *  设置属性值[微信公众号]
     *  @param wxaccountname
     */
    public void setWxaccountname(String wxaccountname){
        if(StringUtils.isEmpty(wxaccountname))
            wxaccountname=null;
        this.wxaccountname = wxaccountname;
        this.set("wxaccountnamedirtyflag",true);
    }
    /**
     *  获取属性值[微信公众号]
     */
    public String getWxaccountname(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.wxaccountname)&&(!StringUtils.isEmpty(this.getWxaccountid())) && this.getWxaccount()!=null)
        {
            this.wxaccountname = this.getWxaccount().getWxaccountname();
            this.set("wxaccountnamedirtyflag",true);
        }
        return this.wxaccountname;
    }
    /**
     *  重置属性值[微信公众号]
     */
    public void resetWxaccountname(){
        this.set("wxaccountnamedirtyflag",false);
        this.wxaccountname = null;
    }
    /**
     *  设置属性值[微信部门标识]
     *  @param wxorgsectorid
     */
    public void setWxorgsectorid(String wxorgsectorid){
        if(StringUtils.isEmpty(wxorgsectorid))
            wxorgsectorid=null;
        this.wxorgsectorid = wxorgsectorid;
        this.set("wxorgsectoriddirtyflag",true);
    }
    /**
     *  获取属性值[微信部门标识]
     */
    public String getWxorgsectorid(){
        return this.wxorgsectorid;
    }
    /**
     *  重置属性值[微信部门标识]
     */
    public void resetWxorgsectorid(){
        this.set("wxorgsectoriddirtyflag",false);
        this.wxorgsectorid = null;
    }
    /**
     *  设置属性值[微信部门名称]
     *  @param wxorgsectorname
     */
    public void setWxorgsectorname(String wxorgsectorname){
        if(StringUtils.isEmpty(wxorgsectorname))
            wxorgsectorname=null;
        this.wxorgsectorname = wxorgsectorname;
        this.set("wxorgsectornamedirtyflag",true);
    }
    /**
     *  获取属性值[微信部门名称]
     */
    public String getWxorgsectorname(){
        return this.wxorgsectorname;
    }
    /**
     *  重置属性值[微信部门名称]
     */
    public void resetWxorgsectorname(){
        this.set("wxorgsectornamedirtyflag",false);
        this.wxorgsectorname = null;
    }
     /**
     *  获取主实体关联数据[OrgSector]
     */
    public OrgSector getOrgsector() {
        return orgsector;
    }
    /**
     *  设置主实体关联数据[OrgSector]
     */
    public void setOrgsector(OrgSector orgsector) {
        this.orgsector = orgsector;
    }

     /**
     *  获取主实体关联数据[WXAccount]
     */
    public WXAccount getWxaccount() {
        return wxaccount;
    }
    /**
     *  设置主实体关联数据[WXAccount]
     */
    public void setWxaccount(WXAccount wxaccount) {
        this.wxaccount = wxaccount;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetDeptid();
        resetMemo();
        resetOrgsectorid();
        resetOrgsectorname();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetUpdatedate();
        resetUpdateman();
        resetWxaccountid();
        resetWxaccountname();
        resetWxorgsectorid();
        resetWxorgsectorname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WXOrgSector copyTo(WXOrgSector targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WXOrgSector.class, WXOrgSector.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWxorgsectorid();
		return targetEntity;
	}
}